Document (Lucene 3.6.2 API)
Keywords: org.apache.lucene.document.Document class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.document
Class Document

    java.lang.Object
      org.apache.lucene.document.Document

All Implemented Interfaces:
  Serializable

    public final class Document

extends Object
implements Serializable

Documents are the unit of indexing and search. A Document is a set of fields. Each field has a name and a textual value. A field may be `stored` with the document, in which case it is returned with search hits on the document. Thus each document should typically contain one or more stored fields which uniquely identify it.

Note that fields which are not `stored` are not available in documents retrieved from the index, e.g. with `ScoreDoc.doc`, `Searcher.doc(int)` or `IndexReader.document(int)`.

See Also:
  Serialized Form

Constructor Summary
`Document()` Constructs a new document with no fields.

Method Summary
`void` | `add(Fieldable field)` Adds a field to a document.
`String` | `get(String name)` Returns the string value of the field with the given name if any exist in this document, or null.
`byte[]` | `getBinaryValue(String name)` Returns an array of bytes for the first (or only) field that has the name specified as the method parameter.
`byte[][]` | `getBinaryValues(String name)` Returns an array of byte arrays for of the fields that have the name specified as the method parameter.
`float` | `getBoost()` Returns, at indexing time, the boost factor as set by `setBoost(float)`.
`Field` | `getField(String name)` Deprecated. use `getFieldable(java.lang.String)` instead and cast depending on data type.
`Fieldable` | `getFieldable(String name)` Returns a field with the given name if any exist in this document, or null.
`Fieldable[]` | `getFieldables(String name)` Returns an array of `Fieldable`s with the given name.
`List<Fieldable>` | `getFields()` Returns a List of all the fields in a document.
`Field[]` | `getFields(String name)` Deprecated. use `getFieldable(java.lang.String)` instead and cast depending on data type.
`String[]` | `getValues(String name)` Returns an array of values of the field specified as the method parameter.
`void` | `removeField(String name)` Removes field with the specified name from the document.
`void` | `removeFields(String name)` Removes all fields with the given name from the document.
`void` | `setBoost(float boost)` Sets a boost factor for hits on any field of this document.
`String` | `toString()` Prints the fields of a document for human consumption.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Document

    public Document()

  Constructs a new document with no fields.

Method Detail

### setBoost

    public void setBoost(float boost)

  Sets a boost factor for hits on any field of this document. This value will be multiplied into the score of all hits on this document.

  The default value is 1.0.

  Values are multiplied into the value of `Fieldable.getBoost()` of each field in this document. Thus, this method in effect sets a default boost for the fields of this document.

  See Also:
    `Fieldable.setBoost(float)`

### getBoost

    public float getBoost()

  Returns, at indexing time, the boost factor as set by `setBoost(float)`.

  Note that once a document is indexed this value is no longer available from the index. At search time, for retrieved documents, this method always returns 1. This however does not mean that the boost value set at indexing time was ignored - it was just combined with other indexing time factors and stored elsewhere, for better indexing and search performance. (For more information see the "norm(t,d)" part of the scoring formula in `Similarity`.)

  See Also:
    `setBoost(float)`

### add

    public final void add(Fieldable field)

  Adds a field to a document. Several fields may be added with the same name. In this case, if the fields are indexed, their text is treated as though appended for the purposes of search.

  Note that add like the removeField(s) methods only makes sense prior to adding a document to an index. These methods cannot be used to change the content of an existing index! In order to achieve this, a document has to be deleted from an index and a new changed version of that document has to be added.

### removeField

    public final void removeField(String name)

  Removes field with the specified name from the document. If multiple fields exist with this name, this method removes the first field that has been added. If there is no field with the specified name, the document remains unchanged.

  Note that the removeField(s) methods like the add method only make sense prior to adding a document to an index. These methods cannot be used to change the content of an existing index! In order to achieve this, a document has to be deleted from an index and a new changed version of that document has to be added.

### removeFields

    public final void removeFields(String name)

  Removes all fields with the given name from the document. If there is no field with the specified name, the document remains unchanged.

  Note that the removeField(s) methods like the add method only make sense prior to adding a document to an index. These methods cannot be used to change the content of an existing index! In order to achieve this, a document has to be deleted from an index and a new changed version of that document has to be added.

### getField

    @Deprecated
    public final Field getField(String name)

  Deprecated. use `getFieldable(java.lang.String)` instead and cast depending on data type.

  Returns a field with the given name if any exist in this document, or null. If multiple fields exists with this name, this method returns the first value added. Do not use this method with lazy loaded fields or `NumericField`.

  Throws:
    `ClassCastException` - if you try to retrieve a numerical or lazy loaded field.

### getFieldable

    public Fieldable getFieldable(String name)

  Returns a field with the given name if any exist in this document, or null. If multiple fields exists with this name, this method returns the first value added.

### get

    public final String get(String name)

  Returns the string value of the field with the given name if any exist in this document, or null. If multiple fields exist with this name, this method returns the first value added. If only binary fields with this name exist, returns null. For `NumericField` it returns the string value of the number. If you want the actual `NumericField` instance back, use `getFieldable(java.lang.String)`.

### getFields

    public final List<Fieldable> getFields()

  Returns a List of all the fields in a document.

  Note that fields which are not `stored` are not available in documents retrieved from the index, e.g. `Searcher.doc(int)` or `IndexReader.document(int)`.

### getFields

    @Deprecated
    public final Field[] getFields(String name)

  Deprecated. use `getFieldable(java.lang.String)` instead and cast depending on data type.

  Returns an array of `Field`s with the given name. This method returns an empty array when there are no matching fields. It never returns null. Do not use this method with lazy loaded fields or `NumericField`.

  Parameters:
    `name` - the name of the field
  Returns:
    a `Field[]` array
  Throws:
    `ClassCastException` - if you try to retrieve a numerical or lazy loaded field.

### getFieldables

    public Fieldable[] getFieldables(String name)

  Returns an array of `Fieldable`s with the given name. This method returns an empty array when there are no matching fields. It never returns null.

  Parameters:
    `name` - the name of the field
  Returns:
    a `Fieldable[]` array

### getValues

    public final String[] getValues(String name)

  Returns an array of values of the field specified as the method parameter. This method returns an empty array when there are no matching fields. It never returns null. For `NumericField`s it returns the string value of the number. If you want the actual `NumericField` instances back, use `getFieldables(java.lang.String)`.

  Parameters:
    `name` - the name of the field
  Returns:
    a `String[]` of field values

### getBinaryValues

    public final byte[][] getBinaryValues(String name)

  Returns an array of byte arrays for of the fields that have the name specified as the method parameter. This method returns an empty array when there are no matching fields. It never returns null.

  Parameters:
    `name` - the name of the field
  Returns:
    a `byte[][]` of binary field values

### getBinaryValue

    public final byte[] getBinaryValue(String name)

  Returns an array of bytes for the first (or only) field that has the name specified as the method parameter. This method will return `null` if no binary fields with the specified name are available. There may be non-binary fields with the same name.

  Parameters:
    `name` - the name of the field.
  Returns:
    a `byte[]` containing the binary field value or `null`

### toString

    public final String toString()

  Prints the fields of a document for human consumption.

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD